/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.jobnet.interfaces;

/**
* \class IWaitHandler 
* 
* \brief IWaitHandler - 
* 
* \details
*
* \section IWaitHandler.java_intro_sec Introduction
*
* \section IWaitHandler.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id: IWaitHandler.java 16850 2012-03-21 12:14:23Z oh $
* \see reference
*
* Created on 24.02.2012 14:20:29
 */
public interface IWaitHandler {
	
	/**
	 * \brief isBootstrap
	 *
	 * \details
	 *
	 * @return true if current order is a bootstrap
	 */
	public abstract boolean isBootstrap();

	
	/**
	 * \brief setwaiterStatusToRunning - 
	 *
	 * \details
	 */
	public abstract void setWaiterStatusToRunning();

	/**
	 * \brief setnodeStatusToRunning - 
	 *
	 * \details
	 */
	public abstract void setNodeStatusToRunning();

	/**
	 * \brief isWaiterSkipped
	 *
	 * \details
	 *
	 * @return true if waiter is skipped
	 */
	public abstract boolean isWaiterSkipped();

	/**
	 * \brief isRunnerSkipped
	 *
	 * \details
	 *
	 * @return true if runner is skipped
	 */
	public abstract boolean isRunnerSkipped();
	
	/**
	 * \brief isRunnerOnDemand
	 *
	 * \details
	 *
	 * @return true if runner on demand
	 */
	public abstract boolean isRunnerOnDemand();
	
	/**
	 * \brief isRunnerRunning
	 *
	 * \details
	 *
	 * @return true if runner is running
	 */
	public abstract boolean isRunnerRunning();

	/**
	 * \brief setnodeStatusToWaiting - 
	 *
	 * \details
	 */
	public abstract void setNodeStatusToWaiting();

	/**
	 * \brief setrunnerStatusToRunning - 
	 *
	 * \details
	 */
	public abstract void setRunnerStatusToRunning();

	/**
	 * \brief setwaiterStatusToFinish - 
	 *
	 * \details
	 */
	public abstract void setWaiterStatusToFinish();

	/**
	 * \brief setwaiterStatusToError - 
	 *
	 * \details
	 */
	public abstract void setWaiterStatusToError();

	/**
	 * \brief setnodeStatusToError - 
	 *
	 * \details
	 */
	public abstract void setNodeStatusToError();
	
	/**
	 * \brief setStartTime - 
	 *
	 * \details
	 */
	public abstract void setStartTime();

	/**
	 * \brief isBootstrap
	 *
	 * \details
	 *
	 * @return int number of uncompleted predecessor nodes
	 */
	public abstract int getNumberOfWaitingNodes();
	
	public abstract IJobNetCollection getWaitingNodes();
	
	public abstract void open();
	public abstract void refresh();
	public abstract void close();
}
