/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.jobnet.jobs;

//import JobSchedulerJobAdapter;
import java.io.IOException;

import org.apache.log4j.Logger;

import sos.scheduler.job.JobSchedulerJobAdapter;

import com.sos.JSHelper.Exceptions.JobSchedulerException;
import com.sos.jobnet.dispatcher.JobNetDispatcher;
import com.sos.jobnet.interfaces.IJobNetCallback;
import com.sos.jobnet.interfaces.IPlanItem;
import com.sos.jobnet.options.JobNetOptions;
import com.sos.jobnet.waiter.JobNetWaiter;
import com.sos.scheduler.model.SchedulerObjectFactory;
import com.sos.scheduler.model.answers.Answer;
import com.sos.scheduler.model.answers.ERROR;
import com.sos.scheduler.model.commands.JSCmdAddOrder;
import com.sos.scheduler.model.objects.JSObjOrder;
import com.sos.scheduler.model.objects.Param;
import com.sos.scheduler.model.objects.Params;
import com.sos.scheduler.model.objects.Spooler;

/**
 * \class JobNetWaitAndDispatch 
 * 
 * \brief JobNetWaitAndDispatch - 
 * 
 * \details
 *
 *
 * \code
 *   .... code goes here ...
 * \endcode
 *
 * <p style="text-align:center">
 * <br />---------------------------------------------------------------------------
 * <br /> APL/Software GmbH - Berlin
 * <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
 * <br />---------------------------------------------------------------------------
 * </p>
 * \author KB
 * \version $Id$
 * \see reference
 *
 * Created on 28.02.2012 13:10:54
 */

/**
 * @author KB
 * 
 */
public class JobNetWaitAndDispatch extends JobSchedulerJobAdapter implements
		IJobNetCallback {

	private final String conClassName = "JobNetWaitAndDispatch";
	@SuppressWarnings("unused")
	private static final String conSVNVersion = "$Id$";
	@SuppressWarnings("hiding")
	private static final Logger logger = Logger
			.getLogger(JobNetWaitAndDispatch.class);
	private boolean flgRunnerIsSkipped = false;
	private boolean flgWaiterOK = true;

	public JobNetWaitAndDispatch() {
		//
	}

	public boolean spooler_process_before() {
		final String conMethodName = conClassName + "::spooler_process_before";
		flgRunnerIsSkipped = false;
		flgWaiterOK = true;
		try {
			initialize();
			logger.info(conMethodName);
			JobNetWaiter jobNetWaiter = new JobNetWaiter();
			JobNetOptions objO = jobNetWaiter.Options();
			jobNetWaiter.setIJobNetCallback(this);
//			jobNetWaiter
//			.setOptionsUsingHashMap(getSchedulerParameterAsProperties(getJobOrOrderParameters()));
			jobNetWaiter.setOptionsUsingHashMap(getAllParametersAsProperties());
//			if (objO.scheduler_id.isDirty() == false) {
//				objO.scheduler_id.Value(this.spooler.id());
//			}
			objO.scheduler_id.Value(this.spooler.id());
			//TODO getJobCHainName
//			String jobChain = "/"+spooler_task.order().job_chain().name();
			String orderId = spooler_task.order().id();
			logger.info(String.format("Checking order %1s in job chain %2s ",orderId,objO.jobnet.Value()));

//			objO.jobnet.Value(jobChain);
			objO.node.Value(orderId); 			
			
			setCheckMandatory(objO);
			objO.CheckMandatory();
			jobNetWaiter.doInit();
			flgWaiterOK = jobNetWaiter.run();
		} catch (Exception e) {
			flgWaiterOK = false;
			raiseException(e);
		}
		return (flgRunnerIsSkipped == false && flgWaiterOK);
	}

	public void spooler_task_after() {

		if (flgWaiterOK) {
			final String conMethodName = conClassName + "::spooler_task_after";
			try {
				initialize();
				logger.info(conMethodName);
				JobNetDispatcher jobNetDispatcher = new JobNetDispatcher();
				JobNetOptions objO = jobNetDispatcher.Options();

				jobNetDispatcher.setIJobNetCallback(this);
//				jobNetDispatcher
//				.setOptionsUsingHashMap(getSchedulerParameterAsProperties(getJobOrOrderParameters()));
				jobNetDispatcher.setOptionsUsingHashMap(getAllParametersAsProperties());
				objO.scheduler_id.Value(this.spooler.id());
				//TODO getJobCHainName
//				String jobChain = "/"+spooler_task.order().job_chain().name();
				String orderId = spooler_task.order().id();
				logger.info(String.format("Checking order %1s in job chain %2s ",orderId,objO.jobnet.Value()));

//				objO.jobnet.Value(jobChain);
				objO.node.Value(orderId);
				
				setCheckMandatory(objO);
				jobNetDispatcher.Options().CheckMandatory();
				jobNetDispatcher.doInit();
				jobNetDispatcher.run();
			} catch (Exception e) {
				raiseException(e);
			}
		}
	}

	private void initialize() {
		initializeLog4jAppenderClass();
	}

	private void raiseException(Exception e) {
		e.printStackTrace(System.err);
		throw new JobSchedulerException(e.getMessage(), e);
	}

	// TODO move to optionsClass !!!!!!!!!!!!!!!!!!!!!!!
	private void setCheckMandatory(JobNetOptions objOptions) {
		//Das fliegt hier raus und kommt in die Options.
		objOptions.uuid_jobnet_identifier.isMandatory(true);
		objOptions.hibernate_connection_config_file.isMandatory(true);
		objOptions.scheduler_id.isMandatory(true);
		objOptions.jobnet.isMandatory(true);
		objOptions.node.isMandatory(true);
 	}

	@Override
	public int getExitCode() {
		return spooler_task.exit_code();
	}

	@Override
	public void setStateText(String stateText) {
		this.spooler_task.order().set_state_text(stateText);
	}

	@Override
	public void startNode(IPlanItem planItem) {
		
		
		logger.debug(String.format("Starting Plan.Node: %1s.%2s",planItem.getPlanId(),planItem.getNodeId()));
		logger.debug(String.format("  Node: %1s",planItem.getJobnetNodeItem().getNode()));
		logger.debug(String.format("  in Net: %1s",planItem.getJobnetNodeItem().getJobnet()));
		logger.debug(String.format("  XML: %1s",planItem.getOrderXml()));
		
		SchedulerObjectFactory objSchedulerObjectFactory = null;
		objSchedulerObjectFactory = new SchedulerObjectFactory(	spooler.hostname(), spooler.tcp_port());
		objSchedulerObjectFactory.initMarshaller(Spooler.class);
		JSCmdAddOrder objAddOrder = objSchedulerObjectFactory.createAddOrder();

		JSObjOrder objOrder = new JSObjOrder(objSchedulerObjectFactory);
		
		objOrder.getOrderFromXMLString(planItem.getOrderXml());

		objAddOrder.setId(planItem.getJobnetNodeItem().getNode());
		objAddOrder.setJobChain(planItem.getJobnetNodeItem().getJobnet());
		objAddOrder.setParams(objOrder.getParams());
		objAddOrder.setReplace("yes");
		spooler_log.info("--------> " + objOrder.getState());
		objAddOrder.setState(objOrder.getState());
		objAddOrder.setTitle(objOrder.getTitle());
		objAddOrder.setAt("now");
		
 		Params objParams = objOrder.getParams();
		Param param = new Param();
		param.setValue(planItem.getUuid());
		param.setName("uuid_jobnet_identifier");
		
		objParams.getParamOrCopyParamsOrInclude().add(param);
		
		param = new Param();
		param.setValue(planItem.getJobnetNodeItem().getJobnet());
		param.setName("jobnet");
		
		objParams.getParamOrCopyParamsOrInclude().add(param);
		
 		objAddOrder.setParams(objParams);		
		
		try{
    		objAddOrder.run();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		Answer objA = objOrder.getAnswer();
		ERROR objE = objA.getERROR();
		if (objE != null) {
			logger.error("order not started. " + objE.getText());
		}

		try {
			objSchedulerObjectFactory.getSocket().doClose();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void skipRunner() {
		flgRunnerIsSkipped = true;
	}
}
