/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.model.objects;

import java.io.File;

import org.apache.log4j.Logger;

import com.sos.VirtualFileSystem.Interfaces.ISOSVirtualFile;
import com.sos.scheduler.model.SchedulerObjectFactory;

/**
* \class JSObjJobChain 
* 
* \brief JSObjJobChain - 
* 
* \details
*
* \section JSObjJobChain.java_intro_sec Introduction
*
* \section JSObjJobChain.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$
* \see reference
*
* Created on 09.02.2011 14:37:58
 */

/**
 * @author oh
 *
 */

public class JSObjJobChain extends JobChain {

	public static final String	conNO				= "no";
	public static final String	conYES				= "yes";
	private final String		conClassName		= "JSObjJobChain";
	@SuppressWarnings("unused")
	private static final Logger	logger				= Logger.getLogger(JSObjJobChain.class);

	public final static String	fileNameExtension	= ".job_chain.xml";

	public JSObjJobChain(final SchedulerObjectFactory schedulerObjectFactory) {
		super();
		objFactory = schedulerObjectFactory;
		super.strFileNameExtension = fileNameExtension;
	}

	public JSObjJobChain(final SchedulerObjectFactory schedulerObjectFactory, final JobChain origOrder) {
		this(schedulerObjectFactory);
		setObjectFieldsFrom(origOrder);
	}

	public JSObjJobChain(final SchedulerObjectFactory schedulerObjectFactory, final ISOSVirtualFile pobjVirtualFile) {
		this(schedulerObjectFactory);
		JobChain objJobChain = (JobChain) unMarshal(pobjVirtualFile);
		setObjectFieldsFrom(objJobChain);
		setHotFolderSrc(pobjVirtualFile);
		super.objVirtualFile = pobjVirtualFile;
	}

	/**
	 * 
	 * \brief setOrdersRecoverable
	 * 
	 * \details
	 *
	 * \return void
	 *
	 * @param pflgIsOrdersRecoverable
	 */
	public void setOrdersRecoverable(final boolean pflgIsOrdersRecoverable) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setOrdersRecoverable";
		if (canUpdate() && pflgIsOrdersRecoverable != getYesOrNo(this.getOrdersRecoverable())) {
			if (pflgIsOrdersRecoverable == true) {
				this.setOrdersRecoverable(conYES);
			}
			else {
				this.setOrdersRecoverable(conNO);
			}
			setDirty();
		}
	} // public void setOrdersRecoverable

	/**
	 * 
	 * \brief setVisible
	 * 
	 * \details
	 *
	 * \return void
	 *
	 * @param pflgIsVisible
	 */
	public void setVisible(final boolean pflgIsVisible) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setVisible";
		if (canUpdate()) {
			if (pflgIsVisible == true) {
				this.setVisible(conYES);
			}
			else {
				this.setVisible(conNO);
			}
			setDirty();
		}
	} // public void setVisible

	/**
	 * 
	 * \brief setDistributed
	 * 
	 * \details
	 *
	 * \return void
	 *
	 * @param pflgIsDistributed
	 */
	public void setDistributed(final boolean pflgIsDistributed) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setDistributed";

		if (canUpdate() && getYesOrNo(super.getDistributed()) != pflgIsDistributed) {
			if (pflgIsDistributed == true) {
				this.setDistributed(conYES);
			}
			else {
				this.setDistributed(conNO);
			}
			setDirty();
		}
	} // public void setDistributed

	@Override
	public String getObjectName() {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::getJobName";

		String name = this.getHotFolderSrc().getName();
		if (name == null) {
			name = "???";
		}
		else {
			name = name.substring(0, name.indexOf(JSObjJobChain.fileNameExtension));
			name = new File(name).getName();
		}

		return name;

	} // private String getJobName

	@Override
	public String getObjectNameAndTitle() {
		String strT = this.getObjectName();
		String strV = this.getTitle();
		if (strV != null && strV.isEmpty() == false) {
			strT += " - " + this.getTitle();
		}
		return strT;
	}

	@Override
	public void setName(final String pstrName) {
		if (canUpdate() == false) {
			return;
		}

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setName";
		// TODO Check for valid name
		String strOldName = getObjectName();
		if (strOldName.equals(pstrName) == false) {
			changeSourceName(pstrName);
			super.setName(pstrName);
			setDirty();
			// TODO rename filename ?
			//			getHotFolderSrc().rename(strNewName);
		}
	} // private void setName

	@Override
	public void setTitle(final String pstrTitle) {
		if (canUpdate() == false) {
			return;
		}

		String strOldTitle = getTitle();
		if (strOldTitle.equals(pstrTitle) == false) {
			super.setTitle(pstrTitle);
			setDirty();
		}
	}

	public void setMaxorders(final String strMaxOrders) {
		if (canUpdate() == false) {
			return;
		}
		int maxOrders;
		try {
			maxOrders = Integer.parseInt(strMaxOrders);
			setMaxorders(maxOrders);
		}
		catch (NumberFormatException e) {
			maxOrders = 0;
		}
	}

	public void setMaxorders(final int maxOrders) {
		// TODO maxOrders nicht im XML?
		//		super.setMaxOrders(maxOrders);
		setDirty();
	}

	public boolean isDistributed() {
		return getYesOrNo(distributed);
	}

	public boolean isRecoverable() {
		return getYesOrNo(getOrdersRecoverable());
	}

	public boolean isVisible() {
		return getYesOrNo(getVisible());
	}

	public String getMaxOrders() {
		Integer intM = getmaxOrders();
		String strM = "";
		if (intM != null) {
			strM = String.valueOf(intM);
		}
		return strM;
	}

}
