/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "precomp.h"
//#define MODULE_NAME "soslimt2"
//#define COPYRIGHT   "1995 SOS GmbH Berlin"
//#define AUTHOR      "Joacim Zschimmer"

//#pragma implementation

#include "sosstrng.h"         // Fr storable.h: Storable_as<Sos_string>
#include "sos.h"
#include "sosfield.h"
#include "soslimtx.h"

using namespace std;
namespace sos {

// Aus soslimtx.cxx herausgelst, damit Solaris C++ 4.0.1 zufrieden ist

//------------------------------------------------------------Sos_limited_text_type::_type_info

Type_info Sos_limited_text_type::_type_info;

SOS_INIT( sos_limited_text )
{
    Sos_limited_text_type::_type_info._std_type      = std_type_varchar;
    Sos_limited_text_type::_type_info._name          = "Sos_limited_text";
    Sos_limited_text_type::_type_info._max_size      = 32000;
    Sos_limited_text_type::_type_info._max_precision = 32000;
    Sos_limited_text_type::_type_info.normalize();
};

//-------------------------------------------------Sos_limited_text_type::Sos_limited_text_type

Sos_limited_text_type::Sos_limited_text_type( int size )
:
    _size ( size )
{
    Sos_limited_text<1>* t = NULL;
    _field_size = (Byte*)&t->_text[0] + sizeof t->_text - 1 - (Byte*)t + size;
  //_field_size = sizeof (Sos_limited_text<1>) - 1 + size;
}

//------------------------------------------------------------Sos_limited_text_type::_get_param

void Sos_limited_text_type::_get_param( Type_param* param ) const
{
    param->_info_ptr     = &_type_info;
    param->_precision    = _size;
}

//-------------------------------------------------------------Sos_limited_text_type::construct

void Sos_limited_text_type::construct( Byte* p ) const
{
    new (p) String0_area( ((Sos_limited_text<1>*)p)->_text, _size );
    ((String0_area*)p)->_length = 0;
}

//------------------------------------------------------------Sos_limited_text_type::field_copy

void Sos_limited_text_type::field_copy( Byte* p, const Byte* s ) const
{
    construct( p );
    ((String0_area*)p)->length( ((String0_area*)s)->length() );
    memcpy( ((Sos_limited_text<1>*)p)->_text, ((Sos_limited_text<1>*)s)->_text,
            ((Sos_limited_text<1>*)s)->length() );
}

//-------------------------------------------------------------------add_sos_limited_text_field

void add_sos_limited_text_field(
    Record_type* t, const String0_area* offset, const char* name, int size,
    const Bool* null_offset, uint flags )
{
    Sos_ptr<Sos_limited_text_type> ft = SOS_NEW( Sos_limited_text_type( size ) );
    t->add_field( ft, name, (long)offset, (long)null_offset, flags );
}

} //namespace sos
