/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: z_mail.cxx 13199 2007-12-06 14:15:42Z jz $

#include "zschimmer.h"
#include "z_mail.h"
#include "log.h"


namespace zschimmer {

//----------------------------------------------------------------------------Email_address::assign
    
void Email_address::assign( const string& name_and_address )
{
    _name    = "";
    _address = "";


    const char* p    = name_and_address.c_str();

    while( p[0] == ' ' )  p++;

    

    if( p[0] == '"' )
    {
        p++;

        while( p[0]  &&  p[0] != '"' )
        {
            if( p[0] == '\\' )  p++;
            _name += p++[0];
        }

        if( p[0] == '"' )  p++;
        while( p[0] == ' ' )  p++;
    }
    else
    {
        while( p[0]  &&  p[0] != '<' )  _name += p++[0];
        _name = rtrim( _name );

        if( !p[0] )  _address = _name,  _name = "";
    }


    if( p[0] == '<' )
    {
        p++;
        while( p[0]  &&  p[0] != '>' )  _address += p++[0];
        if( p[0] == '>' )  p++;
    }

    while( p[0] == ' ' )  p++;

    Z_LOG2( "mail", Z_FUNCTION << "(\"" << name_and_address << "\") ==> \"" << _name << "\", \"" << _address << "\"\n" );

    if( !_suppress_exceptions  &&  p[0] )  throw_xc( "Z-MAIL-001", name_and_address );
}

//---------------------------------------------------------------------Email_address::email_address

string Email_address::email_address() const
{
    if( _name == "" )
    {
        return _address;
    }
    else
    {
        S result;

        result << '"' << _name << '"';     // Fehlt: '"' im Namen bercksichtigen!
        result << " <" << _address << '>';

        return result;
    }
}

//-------------------------------------------------------------------------------------------------


} //namespace zschimmer
