/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: z_posix_mutex.h 12662 2007-03-09 09:17:51Z jz $

#ifndef ZSCHIMMER_Z_POSIX_MUTEX_H
#define ZSCHIMMER_Z_POSIX_MUTEX_H

#ifdef Z_UNIX

#include <pthread.h>

namespace zschimmer {
namespace posix {


typedef pthread_mutex_t         System_mutex;

void                            enter_mutex                 ( System_mutex* );
void                            leave_mutex                 ( System_mutex* );

//------------------------------------------------------------------------------Undestroyable_mutex
// AUFBAU NICHT NDERN, wird mit zur Laufzeit nachgeladenem Modul ausgetauscht!

struct Undestroyable_mutex : zschimmer::Mutex_base
{
                                Undestroyable_mutex         ( const string& name = "", Kind = kind_recursive );
    virtual                    ~Undestroyable_mutex         ();

    void                        enter                       ();
    bool                        try_enter                   ();
    void                        leave                       ();
    Thread_id                   locking_thread_id           ();

    pthread_mutex_t            _system_mutex;
};

//--------------------------------------------------------------------------------------------Mutex

struct Mutex : Undestroyable_mutex
{
                                Mutex                       ( const string& name = "", Kind kind = kind_recursive ) : Undestroyable_mutex( name, kind ) {}
                               ~Mutex                       ();
};

//-------------------------------------------------------------------------------------------------

} //namespace posix
} //namespace zschimmer

#endif
#endif
